unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Gauges, ExtCtrls, IdBaseComponent, IdComponent,
  IdTCPConnection, IdTCPClient, IdHTTP;

type
  TForm1 = class(TForm)
    Frase: TMemo;
    Label1: TLabel;
    Verbos: TListBox;
    Palavs: TListBox;
    Mensag: TLabel;
    Memo1: TMemo;
    Label2: TLabel;
    procedure FraseKeyPress(Sender: TObject; var Key: Char);
  private
  public
    procedure DecodeFrase;
    function LoadArq(NArq: string): boolean;
    procedure Executar;
    function DecodeLin(S: string): integer;
  end;

var
  Form1: TForm1;

implementation
{$R *.DFM}

var
  P1,P2,P3: integer;
  Cp: byte = 0;
  B1,B2,B3: integer;
  CdDc: string;

procedure TForm1.DecodeFrase;
label
  Lp1,Lp2;
var
  S,W: string;
  Tm: integer;
  Pr: boolean;
begin
  P1:= 0; P2:= 0; P3:= 0;
  S:= Frase.Text; Frase.Text:= '';
  Pr:= false;
  S:= trim(S); if S = '' then exit;
  Tm:= pos('-',S);
  if Tm = 0 then Tm:= pos(' ',S) else Pr:= true;
  if Tm = 0 then begin W:= S; S:= '';
  end else begin
           W:= copy(S,1,Tm-1);
           S:= copy(S,Tm+1,length(S));
  end;
  W:= ':' + W + ':';
  //Verifica se  complemento de frase
  if Cp <> 0 then begin
     P1:= B1;
     if Cp = 1 then begin
        Cp:= 0;
        goto Lp1;
     end;
     P2:= B2;
     Cp:= 0;
     goto Lp2;
  end;
  //Indetifica o verbo
  for Tm:= 0 to Verbos.Items.Count-1 do begin
      if pos(W,Verbos.Items[Tm]) <> 0 then begin
         P1:= Tm+1; //Achei paridade
         Break
      end;
  end;
  if S = '' then exit;
  if P1 = 0 then exit;
  if Pr then begin
     P2:= B2;
     Tm:= pos(' ',S);
     if Tm = 0 then begin W:= S; S:= '';
     end else begin
              W:= copy(S,1,Tm-1);
              S:= copy(S,Tm+1,length(S));
     end;
     goto Lp2;
  end;
Lp1:
  S:= trim(S); if S = '' then exit;
  Tm:= pos(' ',S);
  if Tm = 0 then begin W:= S; S:= '';
  end else begin W:= copy(S,1,Tm-1); S:= copy(S,Tm+1,length(S)); end;
  W:= ':' + W + ':';
  //Identifica primeira palavra
  for Tm:= 0 to Palavs.Items.Count-1 do begin
      if pos(W,Palavs.Items[Tm]) <> 0 then begin
         P2:= Tm+1; //Achei paridade
         Break
      end;
  end;
  if S = '' then exit;
  if P2 = 0 then goto Lp1;
Lp2:
  S:= trim(S); if S = '' then exit;
  Tm:= pos(' ',S);
  if Tm = 0 then begin W:= S; S:= '';
  end else begin W:= copy(S,1,Tm-1); S:= copy(S,Tm+1,length(S)); end;
  W:= ':' + W + ':';
  //Identifica segunda palavra
  for Tm:= 0 to Palavs.Items.Count-1 do begin
      if pos(W,Palavs.Items[Tm]) <> 0 then begin
         P3:= Tm+1; //Achei paridade
         Break
      end;
  end;
  if S = '' then exit;
  if P3 = 0 then goto Lp2;
end;


function TForm1.LoadArq(NArq: string): boolean;
begin
  Result:= true;
  if FileExists(NArq) then exit;
  Result:= false;
end;


procedure TForm1.FraseKeyPress(Sender: TObject; var Key: Char);
var
  Tm: integer;
begin
  Key:= UpCase(Key);
  if Key = '' then Key:=''; if Key = '' then Key:='';
  if Key = '' then Key:=''; if Key = '' then Key:='';
  if Key = '' then Key:=''; if Key = '' then Key:='';
  if Key = '' then Key:=''; if Key = '' then Key:='';
  if Key = '' then Key:=''; if Key = '' then Key:='';
  if Key = '' then Key:=''; if Key = '' then Key:='';
  if Key = '' then Key:='';
  if Key = chr(13) then begin
     Mensag.Caption:= ''; Mensag.Repaint;
     Frase.Text:= trim(Frase.Text);
     if Frase.Text = '' then begin
        Mensag.Caption:= 'Especifique o comando desejado.';
        Frase.Text:= ''; Frase.SetFocus;
        exit;
     end;
     DecodeFrase; Frase.Text:= ''; Frase.Repaint;
     B1:= P1; B2:= P2; B3:= P3;
     CdDc:= IntToHex(P1,3)+IntToHex(P2,3)+IntToHex(P3,3)+'.txt';
     Label2.Caption:= CdDc;
     if LoadArq(CdDc) then begin
        Memo1.Lines.LoadFromFile(CdDc);
        Executar;
        Frase.SetFocus;
        exit;
     end;
     Mensag.Caption:= 'Comando desconhecido.';
     Frase.SetFocus;
  end;
end;


//=== Executa um script de texto -----------------------------------------------
procedure TForm1.Executar;
var
  Tm,Tp: integer;
begin
  if Memo1.Lines.Count = 0 then exit;
  Tm:= 0;
  while Tm < Memo1.Lines.Count do begin
        Tp:= DecodeLin(Memo1.Lines[Tm]);
        if Tp = -1 then inc(Tm) else Tm:= Tp;
  end;
end;


//=== Decodifica uma linha do script -------------------------------------------
function TForm1.DecodeLin(S: string): integer;
var
  Cmd: string;
begin
  result:= -1;
  if S = '' then exit;
  while S[1] = ' ' do S:= copy(S,2,length(S));
  Cmd:= '';
  if (S = '') or (S[1] = ':') or (S[1] = '/') then exit;
  if pos(' ',S) = 0 then Cmd:= S
                    else Cmd:= copy(S,1,pos(' ',S)-1);
  S:= copy(S,pos(' ',S)+1,length(S));

  //A partir deste ponto Cmd contm o mnemnico da
  //instruo a ser executada, seguindo o esquema
  //abaixo:

  //-Mensagem de avisdo --- msg texto
  if Cmd = 'msg' then begin
     Mensag.Caption:= S;
     exit;
  end;


end;





end.
